<?php

class tx_multishop_ogone {
	function mslib_payment(&$params, &$ref) {
		// OGONE
		$vars=array();
		$vars['pspid']['type']='input';
		$vars['shasign']['type']='input';
		$vars['paramvar']['type']='input';
		$vars['test']['type']='radio';
		$vars['test']['options'][]='true';
		$vars['test']['options'][]='false';
		$vars['autosubmit']['type']='radio';
		$vars['autosubmit']['options'][]='true';
		$vars['autosubmit']['options'][]='false';
		$vars['open_in_new_window']['type']='radio';
		$vars['open_in_new_window']['options'][]='true';
		$vars['open_in_new_window']['options'][]='false';

		// Guide
		$additional_info=array();

		$step=array();
		$step['label']='Global security parameters / Hash algorithm';
		$step['value']='Go to Global security parameters / Hash algorithm and choose: "SHA-512"';
		$additional_info[]=$step;
		$step=array();
		$step['label']='Global security parameters / Character encoding';
		$step['value']='Go to Global security parameters / Character encoding and choose: "UTF-8"';
		$additional_info[]=$step;
		$step=array();
		$step['label']='Data and origin verification / Checks for e-Commerce / SHA-IN Pass phrase';
		$step['value']='Go to Data and origin verification / Checks for e-Commerce / SHA-IN Pass phrase and fill in your shasign (secret key)';
		$additional_info[]=$step;
		$step=array();
		$step['label']='Transaction feedback / Direct HTTP server-to-server request / URL of the merchant\'s post-payment page';
		$step['value'].='Go to: Timing of the request<br/>';
		$step['value'].='Choose: Online but switch to a deferred request when the online requests fail.<br/><br/>';
		$step['value'].='Go to: If the payment\'s status is "accepted", "on hold" or "uncertain"<br/>';
		$step['value'].='Fill in the following url:<br />'.$ref->FULL_HTTP_URL.mslib_fe::typolink($this->shop_pid.',2002', 'tx_multishop_pi1[page_section]=psp&tx_multishop_pi1[payment_lib]=ogone&tx_multishop_pi1[payment_section]=notification', 1).'<br/><br/>';
		$step['value'].='Go to: If the payment\'s status is "cancelled by the client" or "too many rejections by the acquirer"<br/>';
		$step['value'].='Fill in the following url:<br />'.$ref->FULL_HTTP_URL.mslib_fe::typolink($this->shop_pid.',2002', 'tx_multishop_pi1[page_section]=psp&tx_multishop_pi1[payment_lib]=ogone&tx_multishop_pi1[payment_section]=notification', 1).'<br/><br/>';
		$step['value'].='Go to: Request method<br/>';
		$step['value'].='Choose: POST<br/>';
		$additional_info[]=$step;
		$step=array();
		$step['label']='Transaction feedback / Security for request parameters / SHA-OUT Pass phrase';
		$step['value']='Go to Transaction feedback / Security for request parameters / SHA-OUT Pass phrase and fill in your shasign (secret key)';
		$additional_info[]=$step;
		$step=array();
		$step['label']='MOD Rewrite rules';
		$step['value']='Unfortunately Ingenico does not allow long notification URLs. If your notification URL is chopped when pasting it in the Ingenico dashboard than you can bypass this problem by using below ModRewrite URL. You can add the rule to the .htaccess file in the root of your TYPO3 website.<br />';
		$additional_info[]=$step;
		$step=array();
		$step['value'].='<pre>';
		$step['value'].='RewriteEngine On'."\n";
		$step['value'].='RewriteCond %{REQUEST_URI} ^/ogone/approve_url/'."\n";
		$step['value'].='RewriteRule .* /index.php?id='.$ref->shop_pid.'&type=2002&tx_multishop_pi1\%5Bpage_section\%5D=psp&tx_multishop_pi1\%5Bpayment_lib\%5D=ogone&tx_multishop_pi1\%5Bpayment_section\%5D=notification [P,L]'."\n";
		$step['value'].='</pre>';
		$step['value'].='<br />Note: where id='.$ref->shop_pid.' is the PID where the Multishop core content element is saved on.';
		$additional_info[]=$step;
		$step=array();

		$payment_method=array(
			'name'=>'Ogone',
			'country'=>'nl',
			'vars'=>$vars,
			'more_info_link'=>'http://www.typo3multishop.com/payment-service-providers/ogone/',
			'image'=>'ogone.png',
			'additional_info'=>$additional_info
		);
		// OGONE EOF
		$params['installedPaymentMethods']['ogone']=$payment_method;
	}
}

?>
