<?php
class tx_multishop_payment_method extends mslib_payment {
	function displayPaymentButton($orders_id, $ref) {
		$order=mslib_fe::getOrder($orders_id);
		if ($order['orders_id']) {
			$vars=$this->variables;
			$coBrandDomain='secure.ogone.com';
			if ($vars['test']=='true') {
				$ref->ms['url']='https://'.$coBrandDomain.'/ncol/test/orderstandard_utf8.asp';
			} else {
				$ref->ms['url']='https://'.$coBrandDomain.'/ncol/prod/orderstandard_utf8.asp';
			}
			$order['billing_address']=preg_replace('/\s+/', ' ', $order['billing_address']);
			$order['billing_city']=str_replace(' ', '', $order['billing_city']);
			$order['billing_zip']=str_replace(' ', '', $order['billing_zip']);
			if (!$order['billing_company']) {
				$order['billing_company']=$order['billing_name'];
			}
			$amount=(preg_replace("/^0/", '', $order['total_amount'])*100);
			$transaction_id="PARAMPLUS=".mslib_fe::createPaymentTransactionId($order['orders_id'], 'ogone', $order['payment_method']);
			$formFields=array();
			// Order details
			$formFields['TITLE']=$ref->ms['MODULES']['STORE_NAME'];
			$formFields['AMOUNT']=$amount;
			$formFields['CURRENCY']=$ref->ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3'];
			$formFields['ORDERID']=$order['orders_id'];
			$formFields['PARAMPLUS']=$transaction_id;
			$formFields['PARAMVAR']=$vars['paramvar'];
			$formFields['PM']='IDEAL';
			$formFields['PSPID']=$vars['pspid'];
			// Customer details
			$formFields['LANGUAGE']='nl_NL';
			$formFields['CN']=$order['billing_company'];
			$formFields['EMAIL']=$order['billing_email'];
			$formFields['OWNERADDRESS']=$order['billing_address'];
			$formFields['OWNERZIP']=$order['billing_zip'];
			$formFields['OWNERTOWN']=$order['billing_city'];
			$formFields['OWNERCTY']=$order['billing_country'];
			$formFields['OWNERTELNO']=$order['billing_telephone'];
			// Colors and styling
			$formFields['BGCOLOR']='#ffffff';
			$formFields['BUTTONBGCOLOR']='#AD0101';
			$formFields['BUTTONTXTCOLOR']='#ffffff';
			$formFields['TXTCOLOR']='#333333';
			$formFields['TBLBGCOLOR']='#ffffff';
			$formFields['TBLTXTCOLOR']='#000000';
			$formFields['FONTTYPE']='arial';
			// Return URLs
			$formFields['ACCEPTURL']=$ref->FULL_HTTP_URL.mslib_fe::typolink('', 'tx_multishop_pi1[page_section]=psp_accepturl');
			$formFields['CANCELURL']=$ref->FULL_HTTP_URL.mslib_fe::typolink('', 'tx_multishop_pi1[page_section]=psp_cancelurl');
			$formFields['DECLINEURL']=$ref->FULL_HTTP_URL.mslib_fe::typolink('', 'tx_multishop_pi1[page_section]=psp_exceptionurl');
			$formFields['EXCEPTIONURL']=$ref->FULL_HTTP_URL.mslib_fe::typolink('', 'tx_multishop_pi1[page_section]=psp_exceptionurl');
			// Formfields must be sorted on alphabet
			ksort($formFields);
			// Convert to SHA512
			$hashArray=array();
			foreach ($formFields as $fieldKey=>$fieldVal) {
				if ($fieldVal!='') {
					$hashArray[]=$fieldKey.'='.$fieldVal;
					$hashArray[]=$vars['shasign'];
				}
			}
			$shaString=implode("", $hashArray);
			$shaSign=hash('sha512', $shaString);
			$shaSign=\TYPO3\CMS\Core\Utility\GeneralUtility::strtoupper($shaSign);
			// Render form
			$content.='<form method="post" action="'.$ref->ms['url'].'" id="pspform" name="pspform" target="'.($vars['open_in_new_window']=='true' ? '_blank' : '').'">';
			foreach ($formFields as $fieldKey=>$fieldVal) {
				if ($fieldVal!='') {
					$content.='<input type="hidden" name="'.$fieldKey.'" value="'.$fieldVal.'">'."\n";
				}
			}
			$content.='
			<input type="hidden" name="SHASIGN" value="'.$shaSign.'">
			<input type="submit" name="submit2" value="Veilig betalen via Ingenico" id="ogone_payment_button">';
			$content.='</form>';
			// Autoredirect
			if ($vars['autosubmit']=='true') {
				$GLOBALS['TSFE']->additionalHeaderData['pspFormRedirect']='
				<script type="text/javascript" data-ignore="1">
					jQuery(document).ready(function($){
						setTimeout(function () {
							$("#pspform").attr(\'target\',\'\');
							$("#pspform").submit();
						}, 500);
					});
				</script>';
			}
		}
		return $content;
	}
	function paymentNotificationHandler() {
		$post=$this->ref->post;
		if ($post['STATUS']==9) {
			$transaction_id=$post['PARAMPLUS'];
			if ($transaction_id) {
				$orders_id=mslib_fe::getOrdersIdByTransactionId($transaction_id, 'ogone');
				if ($orders_id) {
					mslib_fe::updateOrderStatusToPaid($orders_id);
				}
			}
		}
		//return $content;
	}
}
?>